/*
 * Tests Ambient's workbench.library.
 *
 * $Id: wblibtest.c,v 1.2 2006/09/18 23:17:35 fab Exp $
 */

#include <dos/dos.h>
#include <proto/dos.h>
#include <proto/wb.h>


struct pathentry {
	BPTR pe_next;
	BPTR pe_lock;
};


static void wbcontrol_searchpath(void)
{
	BPTR path = 0;

	PutStr("Testing WorkbenchControl(NULL, WBCTRLA_DuplicateSearchPath, ...)\n");

	if (WorkbenchControl(NULL, WBCTRLA_DuplicateSearchPath, &path, TAG_DONE))
	{
		struct pathentry *pe = BADDR(path), *peo;

		while (pe)
		{
			TEXT path[1024];

			peo = pe;
			pe = BADDR(pe->pe_next);
			NameFromLock(peo->pe_lock, path, sizeof(path));
			Printf("%s\n", path);
		}
	}
	else
	{
		PutStr("WorkbenchControl() returned FALSE\n");
	}
}


static void openwbobject(void)
{
	PutStr("\nTesting OpenWorkbenchObjectA()\n");

	if (OpenWorkbenchObject("SYS:Prefs", WBOPENA_Show, DDFLAGS_SHOWALL, WBOPENA_ViewBy, DDVM_BYNAME, TAG_DONE))
	{
		PutStr("Succeeded!\n");
	}
	else
	{
		PutStr("Failed!\n");
	}
}


static void wbinfo(void)
{
	BPTR lock;

	PutStr("\nTesting WBInfo()\n");

	lock = Lock("SYS:", ACCESS_READ);

	if (lock)
	{
		WBInfo(lock, "Prefs.info", NULL);
		UnLock(lock);
	}
}


int main(void)
{
	wbcontrol_searchpath();
	openwbobject();
	wbinfo();

	return (0);
}
